/*******************************************************************
*
*  DESCRIPTION: Alarm Register Atomic Model Header File 
*
*  AUTHOR: Christian Jacques
*
*  EMAIL: chris.jacques@videotron.ca
*
*  DATE: 05 Oct 2001
*
*******************************************************************/

#ifndef __ALARMREGISTER_H
#define __ALARMREGISTER_H

#include <list>
#include "atomic.h"     // class Atomic

// AlarmReg class

class AlarmReg : public Atomic
{
public:
	// Constructor
	AlarmReg( const string &name = "AlarmReg" );

	virtual string className() const ;
protected:
	Model &initFunction();
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );

private:

	// input ports
	const Port &alarm_set;
	const Port &hours;
	const Port &minutes;

	// output port
	Port &alarm_time;

	// value of the alarm register
	Time time;

	// output value of time
	Value alarmTime;

};	// class AlarmReg

// ** inline ** // 
inline
string AlarmReg::className() const
{
	return "AlarmReg" ;
}

#endif   //__ALARMREGISTER_H
