/*******************************************************************
*
*  DESCRIPTION: Simulator::registerNewAtomics()
*
*  AUTHOR: Amir Barylko & Jorge Beyoglonian 
*
*  EMAIL: mailto://amir@dc.uba.ar
*         mailto://jbeyoglo@dc.uba.ar
*
*  DATE: 27/6/1998
*
*******************************************************************/

#include "modeladm.h" 
#include "mainsimu.h"
#include "queue.h"      // class Queue
#include "generat.h"    // class Generator
#include "cpu.h"        // class CPU
#include "transduc.h"   // class Transducer
#include "trafico.h"    // class Trafico
#include "hrRegister.h" // class HrReg
#include "minRegister.h" // class MinReg
#include "timeAdder.h" 	// class TimeAdder
#include "alarmRegister.h" 	// class AlarmReg
#include "timeComparator.h" 	// class TimeComp
#include "buzzerDriver.h" 	// class BuzDrv
#include "displayDriver.h" 	// class DispDrv 


void MainSimulator::registerNewAtomics()
{
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Queue>() , "Queue" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Generator>() , "Generator" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<CPU>() , "CPU" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Transducer>() , "Transducer" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Trafico>() , "Trafico" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<HrReg>() , "HrReg" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<MinReg>() , "MinReg" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<AlarmReg>() , "AlarmReg" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<TimeAdder>() , "TimeAdder" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<TimeComp>() , "TimeComp" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<DispDrv>() , "DispDrv" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<BuzDrv>() , "BuzDrv" ) ;
}
