/*******************************************************************
*
*  DESCRIPTION: Time Adder Atomic Model Header File 
*
*  AUTHOR: Christian Jacques
*
*  EMAIL: chris.jacques@videotron.ca
*
*  DATE: 05 October 2001
*
*******************************************************************/

#ifndef __TIMEADDER_H
#define __TIMEADDER_H

#include <list>
#include "atomic.h"     // class Atomic

// TimeAdder class

class TimeAdder : public Atomic
{
public:
	// Constructor
	TimeAdder( const string &name = "TimeAdder" );

	virtual string className() const ;
protected:
	Model &initFunction();
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );

private:

	// input ports
	const Port &time_hours;
	const Port &time_minutes;

	// output port
	Port &time_of_day;

	// value of the time variable
	Time time;

	// value of the time variable converted for output.
	Value outTime;

};	// class TimeAdder

// ** inline ** // 
inline
string TimeAdder::className() const
{
	return "TimeAdder" ;
}

#endif   //__TIMEADDER_H
